﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data;
using System.Configuration;
using System.Data.SqlClient;

namespace Cascading_ComboBox
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cbCountries.DataSource = this.GetData("SELECT CountryId, CountryName FROM Countries");
            cbCountries.DisplayMember = "CountryName";
            cbCountries.ValueMember = "CountryId";
            cbStates.Enabled = false;
            cbCities.Enabled = false;
        }

        private void cbCountries_SelectionChangeCommitted(object sender, EventArgs e)
        {
            cbStates.DataSource = null;
            cbCities.DataSource = null;
            cbStates.Enabled = false;
            cbCities.Enabled = false;
            if (cbCountries.SelectedValue.ToString() != "0")
            {
                string sql = string.Format("SELECT StateId, StateName FROM States WHERE CountryId = {0}", cbCountries.SelectedValue);
                cbStates.DataSource = this.GetData(sql);
                cbStates.DisplayMember = "StateName";
                cbStates.ValueMember = "StateId";
                cbStates.Enabled = true;
            }
        }

        private void cbStates_SelectionChangeCommitted(object sender, EventArgs e)
        {
            cbCities.DataSource = null;
            cbCities.Enabled = false;
            if (cbStates.SelectedValue.ToString() != "0")
            {
                string sql = string.Format("SELECT CityId, CityName FROM Cities WHERE StateId = {0}", cbStates.SelectedValue);
                cbCities.DataSource = this.GetData(sql);
                cbCities.DisplayMember = "CityName";
                cbCities.ValueMember = "CityId";
                cbCities.Enabled = true;
            }
        }

        private void btnSubmit_Click(object sender, EventArgs e)
        {
            string message = "Country: " + cbCountries.Text;
            message += Environment.NewLine;
            message += "State: " + cbStates.Text;
            message += Environment.NewLine;
            message += "City: " + cbCities.Text;
            MessageBox.Show(message);
        }

        private DataTable GetData(string sql)
        {
            string constr = @"Data Source=.\SQL2014;Initial Catalog=Cascading_ddl;Integrated Security=true";
            using (SqlConnection con = new SqlConnection(constr))
            {
                using (SqlDataAdapter sda = new SqlDataAdapter(sql, con))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    DataRow row = dt.NewRow();
                    row[0] = 0;
                    row[1] = "Please select";
                    dt.Rows.InsertAt(row, 0);
                    return dt;
                }
            }
        }
    }
}
